#include <cstdlib>
#include <iostream>
#include <fstream>
#include <vector>
#include <algorithm>
#include <string>
#include <sstream>

#include "timer.h"

#define INPUT_FILE "flood-it.in"
#define OUTPUT_FILE "flood-it.out"

#define MAXM 2
#define EST 20

double TIME_GREEDY1 = 0.91;
double TIME_GREEDY2 = 0.91;
double TIME_BRUTE1 = 0.85;

////////// CHANGE LINE BELOW !!!!!!!!!
#ifdef _DEBUG
#define DEBUG_TIME
#define _MY_DEBUG
#define RESULTS
#endif

using namespace std;

#define MAXN 353
#define MAXNN 124609
#define MAXC 503
#define NEWN 6 // TEST THIS !!!

Timer timer, timer2;

int n, c, nz=0;
int mat[MAXN][MAXN]; // Starts from 1

typedef struct st_zone {
  int x, y, c;
  int s;
  int nnb, mnb;
  vector<int> nb; 
} t_zone;

int cur_zones[MAXC], total_zones[MAXC];
t_zone zones[MAXN*MAXN]; // Starts from 1

void input(const char* fname) {
  ifstream fin(fname);
  fin >> n >> c;
  for (int y = 1; y <= n; ++y) {
    for (int x = 1; x <= n; ++x) {
      fin >> mat[x][y];
    }
  }   
  fin.close();
}

int readnum(char* &p) {
	int res = 0;
	while (*p < 48 || *p > 57) ++p;
	while (*p > 47 && *p < 58) {
		res = res*10 + (*p-48);
		++p;
	}
	return res;
}

void fast_input(const char* fname) {
  ifstream fin(fname, ios::binary);

	fin.seekg(0, ios::end);
	int size = fin.tellg();
	fin.seekg(0, ios::beg);

	char *buf = new char [size+1];
	fin.read(buf, size+1);
	fin.close();

	n = readnum(buf);
	c = readnum(buf);
  for (int y = 1; y <= n; ++y) {
    for (int x = 1; x <= n; ++x) {
      mat[x][y] = readnum(buf);
    }
  }   
}

int que[MAXN*MAXN][2];

void flood1(int x, int y) {
  int qs = 0;
  int qe = 1;
  que[0][0] = x;
  que[0][1] = y;
  int cc = mat[x][y];

  zones[nz].x = x;
  zones[nz].y = y;
  zones[nz].c = cc;
  zones[nz].nnb = 0;
  zones[nz].mnb = NEWN;
  zones[nz].nb.resize(NEWN, 0);
	++total_zones[cc];
  
  while (true) {
    int xx = que[qs][0];
    int yy = que[qs][1];
    ++qs;
    if (mat[xx][yy] != -nz) {
      ++zones[nz].s;
      mat[xx][yy] = -nz;
      if (mat[xx+1][yy] == cc) { que[qe][0] = xx+1; que[qe][1] = yy; ++qe; }
      if (mat[xx-1][yy] == cc) { que[qe][0] = xx-1; que[qe][1] = yy; ++qe; }
      if (mat[xx][yy+1] == cc) { que[qe][0] = xx; que[qe][1] = yy+1; ++qe; }
      if (mat[xx][yy-1] == cc) { que[qe][0] = xx; que[qe][1] = yy-1; ++qe; }
    }
    if (qs == qe) break;
  }
}

int used[MAXN*MAXN];

void add_nb(int z, int t) {
  zones[z].nb[zones[z].nnb++] = t;
  if (zones[z].nnb == zones[z].mnb) {
    zones[z].mnb *= 2;
    zones[z].nb.resize(zones[z].mnb, 0);
  }
  used[t] = z;
}

void flood2(int z) {
  int qs = 0;
  int qe = 1;
  que[0][0] = zones[z].x;
  que[0][1] = zones[z].y;
  int cz = -z;
  used[0] = z;
  used[z] = z;

  while (true) {
    int xx = que[qs][0];
    int yy = que[qs][1];
    ++qs;
    if (mat[xx][yy] != z) {
      mat[xx][yy] = z;
      if (mat[xx+1][yy] == cz) { que[qe][0] = xx+1; que[qe][1] = yy; ++qe; }
      else {
        int t = abs(mat[xx+1][yy]);
        if (used[t] != z) add_nb(z, t);
      }

      if (mat[xx-1][yy] == cz) { que[qe][0] = xx-1; que[qe][1] = yy; ++qe; }
      else {
        int t = abs(mat[xx-1][yy]);
        if (used[t] != z) add_nb(z, t);
      }

      if (mat[xx][yy+1] == cz) { que[qe][0] = xx; que[qe][1] = yy+1; ++qe; }
      else {
        int t = abs(mat[xx][yy+1]);
        if (used[t] != z) add_nb(z, t);
      }

      if (mat[xx][yy-1] == cz) { que[qe][0] = xx; que[qe][1] = yy-1; ++qe; }
      else {
        int t = abs(mat[xx][yy-1]);
        if (used[t] != z) add_nb(z, t);
      }

    }
    
    if (qs == qe) break;
  }
}

typedef struct st_turn {
  int size;
  int nzones;
  int mzones;
  vector<int> zones;
} t_turn;

t_turn turns[MAXC]; // STARTS FROM 1

int cur_m, best_m, best_z;
int cur_sol[MAXN*MAXN];
int best_sol[MAXN*MAXN];

int expanded[MAXN*MAXN];
int sorted_zones[MAXN*MAXN];
int goodn = 0;
int good_zones[MAXNN];

int sp1, sp2;

bool my_compare(const int &a, const int &b) {
	return (zones[a].nnb > zones[b].nnb);
  //return (zones[a].s > zones[b].s);
	//return ((rand()%2) > 0);
}

void init_memory() {
  cur_m = 0;
  best_m = MAXN*MAXN;
  for (int i = 1; i <= c; ++i) {
    turns[i].mzones = NEWN;
    turns[i].zones.resize(NEWN, 0);
  }

	for (int i = 1; i <= nz; ++i) {
    sorted_zones[i] = i;
  }

	sp1 = 1; sp2 = 1;
	for (int i = 1; i <= c; ++i) {
		if (total_zones[i] > total_zones[sp1]) {
			sp2 = sp1;
			sp1 = i;
		} else if (total_zones[i] > total_zones[sp2]) {
			sp2 = i;
		}
	}

#ifdef _MY_DEBUG
  cout << "Top zones: " << sp1 << " " << sp2 << endl;
#endif

	for (int i = nz; i > 1; --i) {
		int tmp = sorted_zones[i];
		int k = rand() % (i) + 1;
		sorted_zones[i] = sorted_zones[k];
		sorted_zones[k] = tmp;
	}
  //sort(sorted_zones+1, sorted_zones+nz+1, my_compare);

}

/////////// ALGORTHM: Greedy 1 /////////
void greedy1() {
  for (int si = 1; si <= nz; ++si) {
    int z = sorted_zones[si];
		if (timer.time() > TIME_GREEDY1) {
#ifdef DEBUG_TIME
			cout << "  scanned " << (si-1) << " zones ... " << endl;
#endif
			break;
		}
    cur_m = 0;
    for (int t = 1; t <= c; ++t) {
      turns[t].size = 0;
      turns[t].nzones = 0;
			cur_zones[t] = total_zones[t];
    }
    expanded[z] = z;
		--cur_zones[zones[z].c];
    for (int i = 0; i < zones[z].nnb; ++i) {
      int k = zones[z].nb[i];
      int cc = zones[k].c;
      expanded[k] = z;
      turns[cc].size += zones[k].s;
      turns[cc].zones[turns[cc].nzones++] = k;
      if (turns[cc].nzones == turns[cc].mzones) {
        turns[cc].mzones *= 2;
        turns[cc].zones.resize(turns[cc].mzones, 0);
      }
    }
    while (true) {
      int bestc = 0;
			int bestn = 0;
      int bestsize = 0;
      for (int i = 1; i <= c; ++i) {
				if (turns[i].nzones == 0) continue;
				if (turns[i].nzones == cur_zones[i]) {
					bestc = i;
					break;
				}
        if (turns[i].size > bestsize) {
				  bestsize = turns[i].size;
          bestc = i;
				}
				//if (turns[i].nzones > bestn) {
				//	bestn = turns[i].nzones;
        //  bestc = i;
				//}
      }
      if (bestc == 0) break;

      cur_sol[cur_m++] = bestc;
			cur_zones[bestc] -= turns[bestc].nzones;

      for (int k = 0; k < turns[bestc].nzones; ++k) {
        int ex = turns[bestc].zones[k];
        expanded[ex] = z;
        for (int j = 0; j < zones[ex].nnb; ++j) {
          if (expanded[zones[ex].nb[j]] == z) continue;
          int exz = zones[ex].nb[j];
          int exc = zones[exz].c;
          expanded[exz] = z;
          turns[exc].size += zones[exz].s;
          turns[exc].zones[turns[exc].nzones++] = exz;
          if (turns[exc].nzones == turns[exc].mzones) {
            turns[exc].mzones *= 2;
            turns[exc].zones.resize(turns[exc].mzones, 0);
          }
        }
      }
      turns[bestc].size = 0;
      turns[bestc].nzones = 0;
    }

    if (cur_m < best_m) {
      best_m = cur_m;
      best_z = z;
#ifdef RESULTS
      cout << "Found " << best_m << " , " << si << " , " << timer2.time() << endl;
#endif
      for (int i = 0; i < cur_m; ++i) {
        best_sol[i] = cur_sol[i];
      }
			good_zones[goodn++] = z;
    }
  }
}

/////////// ALGORTHM: Greedy 2 /////////
int fend;
int *pfront1; int *pfront2; int *pfront_tmp;
int front1[MAXNN], front2[MAXNN];
void greedy2() {
	if (timer.time() > TIME_GREEDY2) {return;}
	int old = 0;
	for (int i = 1; i <= nz; ++i) expanded[i] = 0;
	for (int it = 0; it < 100000; ++it) {
  //for (int si = goodn-1; si >= 0 && si >= (goodn-10); --si) {
	for (int si = 1; si <= 20 && si <= nz; ++si) {
		//if (goodn == 1) {
		//	for (int i = 1; i <= nz; ++i) expanded[i] = 0;
		//}
    //int z = good_zones[si];
		int z = sorted_zones[rand()%nz + 1];
		while (z==old) z=sorted_zones[rand()%nz + 1];
		old = z;
		if (timer.time() > TIME_GREEDY2) {
#ifdef DEBUG_TIME
			cout << "  iteration " << (it+1) << " ... " << endl;
#endif
			return;
		}
    cur_m = 0;
		fend = 0;
		pfront1 = &(front1[0]);
		pfront2 = &(front2[0]);

    for (int t = 1; t <= c; ++t) {
			turns[t].nzones = 0;
			cur_zones[t] = total_zones[t];
    }
    expanded[z] = z;
		--cur_zones[zones[z].c];
		int sure = 0;
    for (int i = 0; i < zones[z].nnb; ++i) {
      int k = zones[z].nb[i];
      expanded[k] = z;
			++turns[zones[k].c].nzones;
			if (turns[zones[k].c].nzones == cur_zones[zones[k].c]) sure = zones[k].c;
			pfront1[fend++] = k;
    }
    while (true) {
      int bestc = 0;
			if (fend == 0) break;
			if (sure == 0) {
				bestc = zones[pfront1[(rand() % fend)]].c;
			} else {
				//cout << "Sure " << endl;
				bestc = sure;
			}
			sure = 0;
      cur_sol[cur_m++] = bestc;

			int y = 0;
			turns[bestc].nzones = 0;
			for (int x = 0; x < fend; ++x) {
				if (zones[pfront1[x]].c == bestc) {
					--cur_zones[bestc];
					int k = pfront1[x];
					for (int j = 0; j < zones[k].nnb; ++j) {
						if (expanded[zones[k].nb[j]] == z) continue;
						int exz = zones[k].nb[j];
						expanded[exz] = z;
						++turns[zones[exz].c].nzones;
						if (turns[zones[exz].c].nzones == cur_zones[zones[exz].c]) sure = zones[exz].c;
						pfront2[y++] = exz;
					}
				}
				else {
					pfront2[y++] = pfront1[x];
				}
			}
			fend = y;
			pfront_tmp = pfront1;
			pfront1 = pfront2;
			pfront2 = pfront_tmp;
    }

    if (cur_m < best_m) {
      best_m = cur_m;
      best_z = z;
#ifdef RESULTS
      cout << "Found " << best_m << " , " << si << " , " << timer2.time() << endl;
#endif
      for (int i = 0; i < cur_m; ++i) {
        best_sol[i] = cur_sol[i];
      }
    }
  }
	}
}

/////////// ALGORTHM: Brute-Force 1 /////////
int sidx = 0;
int eidx = 0;
int moves[MAXM];
bool availc[MAXC];
int summed[MAXNN];

void get_moves() {
	++sidx;
	int m = rand() % c + 1;
	while (!availc[m]) {
		++m;
		if (m > c) m = 1;
	}
	moves[0] = m;
	for (int i = 1; i < MAXM; ++i) {
		moves[i] = rand() % c + 1;
		while (moves[i] == moves[i-1]) moves[i] = rand() % c + 1;
	}
}

int get_moves_size(int l, int zz) {
	int res = 0;
	if (summed[zz] != sidx) {
		res += zones[zz].s;
		summed[zz] = sidx;
	}
	if (l < MAXM-1) {
		for (int i = 0; i < zones[zz].nnb; ++i) {
			if (zones[zones[zz].nb[i]].c == moves[l+1] && expanded[zones[zz].nb[i]] != eidx) {
				res += get_moves_size(l+1, zones[zz].nb[i]);
			}
		}
	}
	return res;
}

void brute1() {
	if (timer.time() > TIME_BRUTE1) {return;}
	int old = 0;
	for (int i = 1; i <= nz; ++i) expanded[i] = 0;
	for (int it = 0; it < 100; ++it) {
	for (int si = 1; si <= nz; ++si) {
		eidx++;
		int z = sorted_zones[rand()%nz + 1];
		while (z==old) z=sorted_zones[rand()%nz + 1];
		old = z;
		if (timer.time() > TIME_BRUTE1) {
#ifdef DEBUG_TIME
			cout << "  iteration " << (it+1) << " ... " << endl;
#endif
			return;
		}
    cur_m = 0;
		fend = 0;
		pfront1 = &(front1[0]);
		pfront2 = &(front2[0]);

    for (int t = 1; t <= c; ++t) {
			turns[t].nzones = 0;
			cur_zones[t] = total_zones[t];
    }
    expanded[z] = eidx;
		--cur_zones[zones[z].c];
		int sure = 0;
    for (int i = 0; i < zones[z].nnb; ++i) {
      int k = zones[z].nb[i];
      expanded[k] = eidx;
			++turns[zones[k].c].nzones;
			if (turns[zones[k].c].nzones == cur_zones[zones[k].c]) sure = zones[k].c;
			availc[zones[k].c] = true;
			pfront1[fend++] = k;
    }
    while (true) {
      int bestc = 0;
			if (fend == 0) break;
			int bestsize = 0;
			for (int i = 0; i < EST; ++i) {
				get_moves();
				int cur = 0;
				for (int v = 0; v < fend; ++v) {
					for (int u = 0; u < MAXM; ++u) {
						if (moves[u] == zones[pfront1[v]].c) {
							cur += get_moves_size(u, pfront1[v]);
							break;
						}
					}
				}
				if (cur > bestsize) {
					bestsize = cur;
					bestc = moves[0];
				}
			}
			sure = 0;
      cur_sol[cur_m++] = bestc;
			availc[bestc] = false;

			int y = 0;
			turns[bestc].nzones = 0;
			for (int x = 0; x < fend; ++x) {
				if (zones[pfront1[x]].c == bestc) {
					--cur_zones[bestc];
					int k = pfront1[x];
					for (int j = 0; j < zones[k].nnb; ++j) {
						if (expanded[zones[k].nb[j]] == eidx) continue;
						int exz = zones[k].nb[j];
						expanded[exz] = eidx;
						++turns[zones[exz].c].nzones;
						availc[zones[exz].c] = true;
						if (turns[zones[exz].c].nzones == cur_zones[zones[exz].c]) sure = zones[exz].c;
						pfront2[y++] = exz;
					}
				}
				else {
					pfront2[y++] = pfront1[x];
				}
			}
			fend = y;
			pfront_tmp = pfront1;
			pfront1 = pfront2;
			pfront2 = pfront_tmp;
    }

    if (cur_m < best_m) {
      best_m = cur_m;
      best_z = z;
#ifdef RESULTS
      cout << "Found " << best_m << " , " << si << " , " << timer2.time() << endl;
#endif
      for (int i = 0; i < cur_m; ++i) {
        best_sol[i] = cur_sol[i];
      }
    }
  }
	}
}

///////////////// OUTPUT
void output(const char* fname) {
  ofstream fout(fname);
  fout << best_m << endl;
  fout << (zones[best_z].y-1) << " " << (zones[best_z].x-1) << endl;
  for (int i = 0; i < best_m; ++i) {
    fout << best_sol[i] << endl;
  }
  fout.close();
}

void fast_output(const char* fname) {
	stringstream res;
	res << best_m << "\n";
  res << (zones[best_z].y-1) << " " << (zones[best_z].x-1) << "\n";
  
  //fout << best_m << endl;
  //fout << (zones[best_z].x-1) << " " << (zones[best_z].y-1) << endl;
  for (int i = 0; i < best_m; ++i) {
		res << best_sol[i] << "\n";
    //fout << best_sol[i] << endl;
  }
	ofstream fout(fname);
	fout << res.str();
  fout.close();
}

int main() {
  timer.start();

  timer2.start();
  fast_input(INPUT_FILE);
#ifdef DEBUG_TIME
  cout << "input() :  " << timer2.time() << endl;
#endif

  timer2.start();
  for (int y = 1; y <= n; ++y) {
    for (int x = 1; x <= n; ++x) {
      if (mat[x][y] <= 0) continue;
      ++nz; flood1(x, y);
    }
  }
#ifdef DEBUG_TIME
  cout << "flood1() :  " << timer2.time() << endl;
#endif

#ifdef DEBUG1
  cout << "Found zones: " << nz << endl;
#endif

  timer2.start();
  for (int i = 1; i <= nz; ++i) {
    flood2(i);
#ifdef DEBUG1
    cout << "Zone #" << i << " neighbours (size = " << zones[i].s << "): ";
    for (int j = 0; j < zones[i].nnb; ++j) {
      cout << zones[i].nb[j] << " ";
    }
    cout << ";" << endl;
#endif
  }
#ifdef DEBUG_TIME
  cout << "flood2() :  " << timer2.time() << endl;
#endif

#ifdef DEBUG2
  for (int y = 1; y <= n; ++y) {
    for (int x = 1; x <= n; ++x) {
      cout << mat[x][y] << " ";
    }
    cout << endl;
  }
#endif

  timer2.start();
  init_memory();
#ifdef DEBUG_TIME
  cout << "init_memory() :  " << timer2.time() << endl;
#endif
  
  timer2.start();
  greedy1();
#ifdef DEBUG_TIME
  cout << "greedy1() :  " << timer2.time() << endl;
#endif
  	
  timer2.start();
  greedy2();
#ifdef DEBUG_TIME
  cout << "greedy2() :  " << timer2.time() << endl;
#endif

  /*
	timer2.start();
	brute1();
#ifdef DEBUG_TIME
  cout << "brute1() :  " << timer2.time() << endl;
#endif
	*/


#ifdef DEBUG3
  cout << "Best: " << best_m << endl;
  cout << "Start: " << (zones[best_z].x-1) << " " << (zones[best_z].y-1) << endl;
  for (int i = 0; i < best_m; ++i) {
    cout << best_sol[i] << " ";
  }
  cout << endl;
#endif

  timer2.start();
  fast_output(OUTPUT_FILE);
#ifdef DEBUG_TIME
  cout << "output() :  " << timer2.time() << endl;
#endif

#ifdef _MY_DEBUG
  cout << "Total zones: " << nz << endl;
  cout << "Total time: " << timer.time() << endl;
	cout << (zones[best_z].y-1) << " " << (zones[best_z].x-1) << endl;

  cout << "Press any key to end program.." << endl;
  cin.get();
#endif

  return 0;
}
